﻿using SyncfusionDiagram.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Xml.Linq;

namespace SyncfusionDiagram.Data
{
    public class MapData
    {        
        public Device Loops { get; private set; }
        public Device Loops2 { get; private set; }
        public MapData()
        {                       
            LoadMap1Data();
            LoadMap2Data();
        }

        public void LoadMap1Data() { Loops = new Device(); LoadMappingData(Loops, "SignatureDevices.xml"); }
        public void LoadMap2Data() { Loops2 = new Device(); LoadMappingData(Loops2, "SignatureDevices1.xml"); }

        private XDocument GetXmlDocument(string fileName)
        {
            XDocument doc = XDocument.Load(AppDomain.CurrentDomain.BaseDirectory + "\\" + fileName);
            return doc;
        }
        XElement currentLoop;
        private void LoadMappingData(Device loops, string fileName)
        {
            try
            {
                var doc = GetXmlDocument(fileName);
                var xmlloops = doc.Element("Root").Elements("LoopController");

                foreach (var lp in xmlloops)
                {
                    currentLoop = lp;
                    Device loopcontroller = new Device();
                    loopcontroller.IconPath = ".././Images\\loopcontroller.png";
                    loopcontroller.Type = "loopcontroller";
                    loopcontroller.Id = lp.Attribute("id").Value;
                    loopcontroller.Name = lp.Attribute("name").Value;
                    loopcontroller.LoopType = lp.Attribute("loop").Value;

                    string pstn = lp.Attribute("position").Value;
                    if (!string.IsNullOrWhiteSpace(pstn))
                    {
                        loopcontroller.Position1 = Point.Parse(lp.Attribute("position").Value);
                        loopcontroller.PositionX = loopcontroller.Position1.X;
                        loopcontroller.PositionY = loopcontroller.Position1.Y;
                    }

                    var devices = lp.Elements("Device");
                    // Device d = new Device();
                    //loopcontroller.Add(d);
                    loops.Add(loopcontroller);
                 
                    AddDevices(loopcontroller, null, devices);
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show("Exception loading data from xml file");
            }
        }
       
        private void AddDevices(Device parentDevice, Device childDevice, IEnumerable<XElement> devices)
        {
            foreach (var item in devices)
            {
                //var idexist = parentDevice.Where(x => x.Id == item.Attribute("id").Value).FirstOrDefault();
                //if (idexist != null)
                //    return;

               // if (childDevice == null)
                    
               // else
                //{

                //}
                childDevice = new Device();
                childDevice.Name = item.Attribute("name").Value;
                childDevice.Id = item.Attribute("id").Value;
                childDevice.Type = item.Attribute("type").Value;
                childDevice.Address = item.Attribute("address").Value;
                childDevice.ConnectedtoDeviceID = item.Attribute("ConnectedtoDeviceID").Value;
                string pstn = item.Attribute("position").Value;
                if (!string.IsNullOrWhiteSpace(pstn))
                {
                    childDevice.Position1 = Point.Parse(item.Attribute("position").Value);
                   

                    childDevice.PositionX = childDevice.Position1.X;
                    childDevice.PositionY = childDevice.Position1.Y;
                }
                // device.Loop = item.Attribute("loop").Value;
                childDevice.IsMultiDevice = bool.Parse(item.Attribute("ismultidevice").Value);
                if (childDevice.Type.ToLower() == "heat")
                    childDevice.IconPath = ".././Images\\heat.png";
                else if (childDevice.Type.ToLower() == "smoke")
                    childDevice.IconPath = ".././Images\\smoke.png";
                else if (childDevice.Type != null)
                    childDevice.IconPath = ".././Images\\module.png";
                childDevice.SerialNo = item.Attribute("SerialNo").Value;
                childDevice.Model = item.Attribute("Model").Value;
                if (parentDevice != null)
                {
                    parentDevice.Add(childDevice);
                    childDevice.ParentDevice = parentDevice;
                }
                else
                {

                }
                var subdevices = item.Elements("Device");
                if (subdevices.Count() > 0)
                    AddDevices(childDevice, null, subdevices);
                else
                {
                    //TODO: got to childdevice parent in xml and compare its childs count with objects clilds count, if match, go to its parent and perform same operation //in recursive
                    //else it parent = parentDevice.
                   // Device device = CheckParent(childDevice);
                   // parentDevice = device;
                }
            }
        }
        //Device ActualParent = null;
        //Device CheckParent(Device childDevice)
        //{

        //    Device parentDevice = childDevice.ParentDevice;
        //    var pdevice = currentLoop.Descendants("Device").Where(x => x.Attribute("id").Value == parentDevice.Id);

        //    if (pdevice != null)
        //    {
        //        var pcount = pdevice.Elements("Device").Count();
        //        if (pcount == parentDevice.Count)
        //        {
        //            CheckParent(parentDevice);
        //        }
        //        else
        //        {
        //            ActualParent = parentDevice;
        //            //  var loopType = currentLoop.Attribute("loop").Value;


        //            // var vv = Loops.Where(x => x.LoopType == loopType);
        //            //  navigateToNode(vv);

        //        }
        //    }
        //    return ActualParent;
        //}

        //private Device navigateToNode(IEnumerable<Device> loopDevices)
        //{
        //    throw new NotImplementedException();



        //}

        public void SaveToXML(Device SelectedLoop)
        {
            var doc = GetXmlDocument("SignatureDevices.xml");
            var lcs = doc.Element("Root").Elements("LoopController");

            var sellp = lcs.FirstOrDefault(x => x.Attribute("loop").Value == SelectedLoop.LoopType);
            sellp.Attribute("position").Value = SelectedLoop.PositionX.ToString()+","+SelectedLoop.PositionY.ToString();
            //foreach (var lc in lcs)
            //{
            var devices = sellp.Descendants("Device");
            //foreach (var item in SelectedLoop)
            //{
            //    var xx = devices.Where(x => x.Attribute("name").Value == item.Name).FirstOrDefault();
            //    if (xx != null)
            //        xx.Attribute("position").Value = item.PositionX.ToString() + "," + item.PositionY.ToString();
            //}
            Save(devices, SelectedLoop);
            //if (SelectedTreeLayout != TreeLayoutType.None)
            //    sellp.Attribute("layoutType").Value = SelectedTreeLayout.ToString();
            //}

            doc.Save(AppDomain.CurrentDomain.BaseDirectory + "\\SignatureDevices.xml");
        }

        private void Save(IEnumerable<XElement> elements, Device device)
        {
            foreach (var item in device)
            {
                var xx = elements.Where(x => x.Attribute("name").Value == item.Name).FirstOrDefault();
                if (xx != null)
                    xx.Attribute("position").Value = item.PositionX.ToString() + "," + item.PositionY.ToString();
                if (item.Count > 0)
                    Save(elements, item);
            }
        }
    }


}
