﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;

namespace SyncfusionDiagram.Models
{
    public class Device : ObservableCollection<Device>, IDevice
    {
        public Device()
        {

        }

        public Device(IEnumerable<Device> devices)
        {
            foreach (var item in devices)
            {
                this.Add(item);
            }
        }

        private Device _ParentDevice;

        public Device ParentDevice
        {
            get { return _ParentDevice; }
            set { _ParentDevice = value; OnPropertyChanged("ParentDevice"); }
        }

        private string _LoopType;

        public string LoopType
        {
            get { return _LoopType; }
            set { _LoopType = value; OnPropertyChanged("LoopType"); }
        }

        private string _Id;

        public string Id
        {
            get { return _Id; }
            set { _Id = value; OnPropertyChanged("Id"); }
        }

        private Point _Position1;

        public Point Position1
        {
            get { return _Position1; }
            set { _Position1 = value; OnPropertyChanged("Position1"); }
        }

        private double _PositionX;

        public double PositionX
        {
            get { return _PositionX; }
            set
            {
                _PositionX = value;
                _Position1.X = value;
                OnPropertyChanged("PositionX");
            }
        }

        private double _PositionY;

        public double PositionY
        {
            get { return _PositionY; }
            set
            {
                _PositionY = value;
                _Position1.Y = value;
                OnPropertyChanged("PositionY");
            }
        }

        private string _Name;

        public string Name
        {
            get { return _Name; }
            set { _Name = value; OnPropertyChanged("Name"); }
        }
        private string _Type;

        public string Type
        {
            get { return _Type; }
            set { _Type = value; OnPropertyChanged("Type"); }
        }

        private string _ConnectedtoDeviceID;
        public string ConnectedtoDeviceID
        {
            get { return _ConnectedtoDeviceID; }
            set { _ConnectedtoDeviceID = value; OnPropertyChanged("ConnectedtoDeviceID"); }
        }

        private bool _IsMultiDevice;

        public bool IsMultiDevice
        {
            get { return _IsMultiDevice; }
            set { _IsMultiDevice = value; OnPropertyChanged("IsMultiDevice"); }
        }
        private string _IconPath;

        public string IconPath
        {
            get { return _IconPath; }
            set { _IconPath = value; OnPropertyChanged("IconPath"); }
        }
        private string _Loop;

        public string Loop
        {
            get { return _Loop; }
            set { _Loop = value; OnPropertyChanged("Loop"); }
        }

        private string _SerialNo;

        public string SerialNo
        {
            get { return _SerialNo; }
            set { _SerialNo = value; OnPropertyChanged("SerialNo"); }
        }

        private string _Model;

        public string Model
        {
            get { return _Model; }
            set { _Model = value; OnPropertyChanged("Model"); }
        }

        private string _Address;

        public string Address
        {
            get { return _Address; }
            set { _Address = value; OnPropertyChanged("Address"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

    }
}


