﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;

namespace SyncfusionDiagram.Models
{
    public class Loop : IDevice
    {
        private Device _LoopDevices = new Device();

        public Device LoopDevices
        {
            get { return _LoopDevices; }
            set
            {
                _LoopDevices = value;
                OnPropertyChanged("LoopDevices");
            }
        }

        private string _Id;

        public string Id
        {
            get { return _Id; }
            set { _Id = value; OnPropertyChanged("Id"); }
        }

        private string _Name;

        public string Name
        {
            get { return _Name; }
            set { _Name = value; OnPropertyChanged("Name"); }
        }
        private string _Type;

        public string Type
        {
            get { return _Type; }
            set { _Type = value; OnPropertyChanged("Type"); }
        }

        private string _ConnectedtoDeviceID;
        public string ConnectedtoDeviceID
        {
            get { return _ConnectedtoDeviceID; }
            set { _ConnectedtoDeviceID = value; OnPropertyChanged("ConnectedtoDeviceID"); }
        }

        private bool _IsMultiDevice;

        public bool IsMultiDevice
        {
            get { return _IsMultiDevice; }
            set { _IsMultiDevice = value; OnPropertyChanged("IsMultiDevice"); }
        }
        private string _IconPath;

        public string IconPath
        {
            get { return _IconPath; }
            set { _IconPath = value; OnPropertyChanged("IconPath"); }
        }
        private string _LoopType;

        public string LoopType
        {
            get { return _LoopType; }
            set { _LoopType = value; OnPropertyChanged("LoopType"); }
        }

        private Point _Position;

        public Point Position
        {
            get { return _Position; }
            set { _Position = value; OnPropertyChanged("Position"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        //#region SignatureGraphSource
        //private SignatureMappings _SignatureGraphSource = new SignatureMappings();

        //public SignatureMappings SignatureGraphSource
        //{
        //    get { return _SignatureGraphSource; }
        //    set { _SignatureGraphSource = value; OnPropertyChanged("SignatureGraphSource"); }
        //}
        //#endregion
    }
}
