﻿using Syncfusion.Windows.Diagram;
using SyncfusionDiagram.Command;
using SyncfusionDiagram.Data;
using SyncfusionDiagram.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SyncfusionDiagram.ViewModel
{
    public class MappingViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        public event EventHandler PreviewLoopChanged;
        public event EventHandler LoopChanged;

        public ChangeLoopCommand ChangeLoopCommand { get; set; }
        public SaveDiagramCommand SaveDiagramCommand { get; set; }
        MapData data;
        public MappingViewModel()
        {
            data = new MapData();
            Loop = data.Loops;           
            ChangeLoopCommand = new ChangeLoopCommand(this);
            SaveDiagramCommand = new SaveDiagramCommand(this);
        }        

        private Device _Loop;
        public Device Loop
        {
            get { return _Loop; }
            set { _Loop = value; OnPropertyChanged("Loop"); }
        }

        public void ChangeLoop(bool change)
        {
            Loop = null;
            if (PreviewLoopChanged != null)
                PreviewLoopChanged(null, null);
            Loop =change ? data.Loops2 : data.Loops;
            if (LoopChanged != null)
                LoopChanged(null, null);
        }

        public void ReloadLoopData()
        {
            if (int.Parse(Loop[0].LoopType) == 1)
            {
                data.LoadMap1Data();
                ChangeLoop(false);
            }
            else
            {
                data.LoadMap2Data();
                ChangeLoop(true);
            }
            
        }
        public void Save()
        {
            data.SaveToXML(Loop[0]);
        }

    }
}
